package javax.swing;

import java.awt.event.ActionEvent;
import java.awt.Point;
import sun.awt.AWTAccessor;
import java.awt.event.MouseEvent;
import java.awt.event.ActionListener;

class Autoscroller implements ActionListener
{
    private static Autoscroller sharedInstance;
    private static MouseEvent event;
    private static Timer timer;
    private static JComponent component;
    
    public static void stop(JComponent component) {
        Autoscroller.sharedInstance._stop(component);
    }
    
    public static boolean isRunning(JComponent component) {
        return Autoscroller.sharedInstance._isRunning(component);
    }
    
    public static void processMouseDragged(MouseEvent mouseEvent) {
        Autoscroller.sharedInstance._processMouseDragged(mouseEvent);
    }
    
    Autoscroller() {
    }
    
    private void start(JComponent component, MouseEvent mouseEvent) {
        Point locationOnScreen = component.getLocationOnScreen();
        if (Autoscroller.component != component) {
            this._stop(Autoscroller.component);
        }
        Autoscroller.component = component;
        Autoscroller.event = new MouseEvent(Autoscroller.component, mouseEvent.getID(), mouseEvent.getWhen(), mouseEvent.getModifiers(), mouseEvent.getX() + locationOnScreen.x, mouseEvent.getY() + locationOnScreen.y, mouseEvent.getXOnScreen(), mouseEvent.getYOnScreen(), mouseEvent.getClickCount(), mouseEvent.isPopupTrigger(), 0);
        AWTAccessor.MouseEventAccessor mouseEventAccessor = AWTAccessor.getMouseEventAccessor();
        mouseEventAccessor.setCausedByTouchEvent(Autoscroller.event, mouseEventAccessor.isCausedByTouchEvent(mouseEvent));
        if (Autoscroller.timer == null) {
            Autoscroller.timer = new Timer(100, this);
        }
        if (!Autoscroller.timer.isRunning()) {
            Autoscroller.timer.start();
        }
    }
    
    private void _stop(JComponent component) {
        if (Autoscroller.component == component) {
            if (Autoscroller.timer != null) {
                Autoscroller.timer.stop();
            }
            Autoscroller.timer = null;
            Autoscroller.event = null;
            Autoscroller.component = null;
        }
    }
    
    private boolean _isRunning(JComponent component) {
        return component == Autoscroller.component && Autoscroller.timer != null && Autoscroller.timer.isRunning();
    }
    
    private void _processMouseDragged(MouseEvent mouseEvent) {
        JComponent component = (JComponent)mouseEvent.getComponent();
        boolean contains = true;
        if (component.isShowing()) {
            contains = component.getVisibleRect().contains(mouseEvent.getX(), mouseEvent.getY());
        }
        if (!(contains == 0)) {
            this._stop(component);
        }
        else {
            this.start(component, mouseEvent);
        }
    }
    
    @Override
    public void actionPerformed(ActionEvent actionEvent) {
        JComponent component = Autoscroller.component;
        if (component == null || !component.isShowing() || Autoscroller.event == null) {
            this._stop(component);
            return;
        }
        Point locationOnScreen = component.getLocationOnScreen();
        MouseEvent mouseEvent = new MouseEvent(component, Autoscroller.event.getID(), Autoscroller.event.getWhen(), Autoscroller.event.getModifiers(), Autoscroller.event.getX() - locationOnScreen.x, Autoscroller.event.getY() - locationOnScreen.y, Autoscroller.event.getXOnScreen(), Autoscroller.event.getYOnScreen(), Autoscroller.event.getClickCount(), Autoscroller.event.isPopupTrigger(), 0);
        AWTAccessor.MouseEventAccessor mouseEventAccessor = AWTAccessor.getMouseEventAccessor();
        mouseEventAccessor.setCausedByTouchEvent(mouseEvent, mouseEventAccessor.isCausedByTouchEvent(Autoscroller.event));
        component.superProcessMouseMotionEvent(mouseEvent);
        return;
    }
    
    static {
        Autoscroller.sharedInstance = new Autoscroller();
    }
}
